/**************************************/
/*    3-D OBJECT DRAWING PROGRAM      */
/*    V. MILLER  JUNE 1997            */
/*    3-D PROJECTION DRAWING PROGRAM  */
/*                                    */
/*    DEPTH SORT FOR HIDDEN POLYGONS  */
/*                                    */
/*    READS *._3D FILES WHICH ARE     */
/*    ASCII VERSIONS OF BINARY *.3DS  */
/*    FILES                           */
/*                                    */
/*    *.3DS FILES ARE CONVERTED TO    */
/*    ASCII *._3D FILES WITH PROGRAM  */
/*    3DSRDR.C FROM FINLAND (x2ftp)   */
/**************************************/

#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include <alloc.h>
#include <bios.h>
#include <process.h>
int graphics_adapter,graphics_mode;
int ixpt,iypt,ipen,i,ipl,iv,ivert,j,k,p,istyle,ixtxt,iytxt;
int nvert,nplate,npvert,nfaces,aa,bb,cc,icolor,itemp;
int inumplate,inumvertice,istartplate,index,npoints,npplate;
int plaray[800],jplate[5][400],jpsort[400][8];
float zdepth, platedepth[2][400];
int face_color[1000];
float scicon,pilotx,piloty,pilotz,vertex[3][1000],faces[3][1000];
float x,y,z,cgx,cgy,cgz;
double xx,yy,zz;
float xa=0.,ya=0.,za=0.;
float xmax,xmin,ymax,ymin,zmax,zmin,xspread,yspread,zspread,spread;
float xmiddle,ymiddle,zmiddle;
float r1=0.,r2=0.,r3=0.;
float sr1=0., sr2=0., sr3=0.;
float cr1=0., cr2=0., cr3=0.;
float rd1=0,rd2=0,rd3=0;
int hertz=100, duration=10000;
float movex=0.,movey=0.,movez=300.;
float sx=0.,sy=0.;
float sxavg,syavg,sxstart,systart,sxseed,syseed;
float sxa=0., sya=0., sxb=0., syb=0.;
float pi=3.141592, d=1200.,a;
float angle,range,radius,xcenter,ycenter,xpt,ypt,xout,yout,xin,yin;
int   iloop, iloop2, iswapflag=1, ipoint,iface;
int iplate_a,iplate_b,iplate_c;
int zin,zout,c;
char string[80],string_value[4],str_pointer;
int istring_start,ivalue,ivert,ix,iy,iz;
float dataarray[2][600];
float tempiplate, tempzdepth;
struct { int x,y ; } points[20];

int t1=0,t2=0,p1=0;
char dummy,buffer[80];
FILE *fp;
void keyboard(void);
void keyboard_input(void);
void calc_3d(void);
void rotation(void);
void vic_sort(void);
float maximum(float x,float y);
float minimum(float x,float y);
main()
{
        fp=fopen("engine._3d","r");         /* open icon file */
/*	printf("Opened File \n");   */
        ipoint=0;
        iface=0;
	while(feof(fp) == 0) {              /* read until End-Of-File is reached */
/*	fread(&string,80,1,fp);  */         /* read line as string */
	fgets(string,80,fp);                /* read line from file as string */
/*	for(i=1;i<=80;i++) {
	printf("%c",string[i-1]); }  */

	istring_start=0;
	str_pointer=strstr(string,"Vertices:");
	if(str_pointer!=NULL) {
/*	printf("Vertices: found at position %i \n",str_pointer);
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}
	keyboard();                                      */
        sscanf(string,"%*s%d",&nvert);
/*	printf("The number of verticies assigned is %i \n",nvert); */
	str_pointer=NULL;
/*	keyboard();        */                         }

	str_pointer=strstr(string,"X:");
	if(str_pointer!=NULL) {
/*	printf("Found X: Y: Z: Data \n");
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}    */
/*	sscanf(string,"%*s%f, %*s%f, %*s%f\n",&x,&y,&z);  */
	sscanf(string,"              X: %f, Y: %f, Z: %f",&x,&y,&z);
        vertex[0][ipoint]=x;
        vertex[1][ipoint]=y;
        vertex[2][ipoint]=z;
        ipoint=ipoint+1;

        xmax=maximum(xmax,x);                  /* find x,y,z mins and maxs for scaling */
        xmin=minimum(xmin,x);
        ymax=maximum(ymax,y);
        ymin=minimum(ymin,y);
        zmax=maximum(zmax,z);
        zmin=minimum(zmin,z);

/*	for(j=1;j<=ivert;j++) {
	fscanf(fp,"%*s%d%*s%d%*s%d \n",&x,&y,&z);   */
/*	printf("Assigned X: %f Y: %f Z: %f \n",x,y,z); */
	str_pointer=NULL;
	/* keyboard(); */   }

	str_pointer=strstr(string,"Faces:");
	if(str_pointer!=NULL) {
/*	printf("Found Face Number \n");        */
        sscanf(string,"%*s%d",&nfaces);
/*	printf("The number of faces is %i \n",nfaces);   */
        str_pointer=NULL;
/*	keyboard();        */    }

        str_pointer=strstr(string,"A:");
	if(str_pointer!=NULL) {
/*	printf("Found Face Data \n");      */
	sscanf(string,"      A: %i, B: %i, C: %i,%i",&aa,&bb,&cc,&icolor);
        faces[0][iface]=aa;
        faces[1][iface]=bb;
	faces[2][iface]=cc;
	face_color[iface]=icolor;
        iface=iface+1;

/*	printf("Assigned Face A: %i B: %i C: %i D: %i \n",aa,bb,cc,icolor); */
	str_pointer=NULL;
	/* keyboard(); */           }
				  }               /* End-Of-File */
/*	printf("Finished Reading Object File");
	keyboard();                             */
        xspread=xmax - xmin;                      /* Find biggest spread in x,y,z */
        yspread=ymax - ymin;
        zspread=zmax - zmin;
        spread=maximum(xspread,yspread);
	spread=maximum(spread,zspread);
/*	printf("The spreads are: T%f  X%f  Y%f  Z%f \n",
		spread,xspread,yspread,zspread);
	keyboard();                                   */

/*	keyboard();                                   */
	detectgraph(&graphics_adapter,&graphics_mode);
        graphics_adapter=EGA; graphics_mode=EGAHI;
	initgraph(&graphics_adapter,&graphics_mode,"");
        setlinestyle(SOLID_LINE,0,THICK_WIDTH);
	cleardevice();

	movez=1200.;
	rd1=0; rd2=0; rd3=0;
				       /* set up initial orientation */
	rd1= 30;
        rd2=-40;
        rd3=-20;
	for(i=1; i!=0; i++ ) {

	rd1=rd1+1;                     /* increment roll pitch yaw angles */
	rd2=rd2-2;
	rd3=rd3-1;

        if(p==1) { setvisualpage(0);        /* DO DOUBLE-BUFFERING */
	for(j=1; j<=6000; j++) {a=sin(1.);}
		   setactivepage(1);}
	if(p==0) { setvisualpage(1);
	for(j=1; j<=6000; j++) {a=sin(1.);}
                   setactivepage(0);}
	p=1-p;

	if(i==1280) goto end_label ;
	cleardevice();
        keyboard_input();

/*      movez=600. +  800.*(sin(3.1415*0.5*i/550.)); */
/*      movex=50.   - 110.*(i/350.);                 */

/*	rd1=rd1+1; rd2=rd2+1; rd3=rd3+2;             */
	r1=(pi/180.)*rd1;
	r2=(pi/180.)*rd2;
	r3=(pi/180.)*rd3;

        rotation();

	iv=1;                                        /* choose view  1 to 8 views */

                                                     /* NOW DRAW THE THING  */
        for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
/*      inumplate=jpsort[ipl][iv];          */
        inumplate=ipl-1;                             /* step through each face           */
                                                     /* gather info for face to be drawn */
                                                     /* 0= A vertex for plate        */
                                                     /* 1= B vertex for plate        */
                                                     /* 2= C vertex for plate        */

        iplate_a =faces[0][inumplate];
        iplate_b =faces[1][inumplate];
        iplate_c =faces[2][inumplate];               /* set pen for this plate */
	if(ipen >=15) ipen=10;
        if(ipen <= 0) ipen=10;                       /* make sure pen is visible */
	setcolor(ipen);

	sxavg=0.;
	syavg=0.;
	npplate=0;
	sxstart=0.;
	systart=0.;
        zdepth=0.;

	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
        npplate=npplate+1;                            /* count points which make up each plate                */
        inumvertice=faces[k-1][inumplate];            /* pick-up vertex numbers sequentially for this face */

        x=vertex[0][inumvertice];                     /* pick-up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];


	x=(x-cgx)*(300./spread);                  /* normalize and scale object coords */
	y=(y-cgy)*(300./spread);
	z=(z-cgz)*(300./spread);

/*	z=z + movez;        */
	if(x==0.) x=.00001;
	if(y==0.) y=.00001;
	if(z==0.) z=.00001;

        calc_3d();                                    /* transform x,y,z  into x,y screen coords */
	sxb=sx+320.;                                  /* center object on screen */
	syb=sy+172.;                                  /* center object on screen */
	zdepth=zdepth+z;}                             /* establish average depth on each plate for depth sorting */
	platedepth[0][inumplate]=inumplate;           /* store plate reference number          for depth sorting */
	platedepth[1][inumplate]=zdepth/npplate;      /* store average z-depth  for each plate for depth sorting */
        };                                            /* close plate loop                                        */

/*--------------------------------------------------------------
        SUBROUTINE:  VIC_SORT = DEPTH SORT BY BUBBLE SORT
        SORT ITEMS BY Z-DEPTH WITH LARGEST Z VALUE FIRST
        TO START DRAWING AT BACK OF SCREEN AND WORK FORWARDS

        OUTER LOOP KEEPS PERFORMING INNER LOOP UNTIL NO MORE SWAPPING OCCURS
        INNER LOOP STEPS THROUGH THE COMPLETE PLATE LIST AND
        COMPARES NEIGHBORING VALUES. WHEN THE FIRST OF THE PAIR
        HAS A SMALLER Z-DEPTH IT SWAPS IT WITH THE SECOND OF THE PAIR
        THIS WILL CONTINUE ALL THE WAY DOWN THE LIST.  WHEN EVERYTHING
        IS IN ORDER NO MORE SWAPS OCCUR AND THE OUTER LOOP STOPS       */



        for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
/*      inumplate=jpsort[ipl][iv];          */
	inumplate=platedepth[0][ipl-1];              /* use plate sequence based upon z-depth sort */
                                                     /* step through each face           */
                                                     /* gather info for face to be drawn */
                                                     /* 0= A vertex for plate        */
                                                     /* 1= B vertex for plate        */
                                                     /* 2= C vertex for plate        */

        iplate_a =faces[0][inumplate];
        iplate_b =faces[1][inumplate];
	iplate_c =faces[2][inumplate];               /* set pen for this plate */
	icolor   =face_color[inumplate];             /* store color for this plate */
	if(icolor >=15) icolor=10;
	if(icolor <= 0) icolor=10;                   /* make sure pen is visible */

	sxavg=0.;
	syavg=0.;
	npplate=0;
	sxstart=0.;
	systart=0.;

	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
        npplate=npplate+1;                            /* count points which make up each plate                */
        index=istartplate + (k-1);
	inumvertice=plaray[index];
        inumvertice=faces[k-1][inumplate];            /* pick-up vertex numbers sequentially for this face */

        x=vertex[0][inumvertice];                     /* pick=up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];

	x=(x-cgx)*(300./spread);                  /* normalize and scale object coords */
	y=(y-cgy)*(300./spread);
	z=(z-cgz)*(300./spread);

/*	z=z + movez;        */
	if(x==0.) x=.00001;
	if(y==0.) y=.00001;
	if(z==0.) z=.00001;

        calc_3d();                                    /* transform x,y,z  into x,y screen coords */
	sxb=sx+320.;                                  /* center object on screen */
	syb=sy+172.;                                  /* center object on screen */
        points[npplate-1].x=sxb;
        points[npplate-1].y=syb;
	if(k==1) {
	sxa=sxb;
	sya=syb;
	sxstart=sxa;
        systart=sya;};
/*        moveto(sxa,sya);       */
/*        lineto(sxb,syb);       */                       /* draw vector            */
        sxa=sxb;                                      /* save last point x      */
        sya=syb;                                      /* save last point y      */
	sxavg=sxavg+sxb;                              /* use x avg to seed fill pt */
	syavg=syavg+syb;}                             /* use y avg to seed fill pt */
        sxavg=sxavg/npplate;
        syavg=syavg/npplate;
        points[npplate].x=sxstart;                    /* return to start point to ensure closed polygon */
	points[npplate].y=systart;                    /* return to start point to ensure closed polygon */
	npplate=4;                                    /* adjust # points by one to return to original start point for closed polygon */
/*        lineto(sxstart,systart);   */               /* close polygon - back to first point */
	sxseed=sxstart;
	syseed=systart;
	if(sxavg > sxseed) {sxseed=sxseed+4;};        /* set seed point for color fill */
	if(sxavg < sxseed) {sxseed=sxseed-4;};        /* set seed point for color fill */
	if(syavg > syseed) {syseed=syseed+4;};        /* set seed point for color fill */
	if(syavg < syseed) {syseed=syseed-4;};        /* set seed point for color fill */

/*	for(itemp=1; itemp<=4; itemp++) {
	printf("nplate= %i Xpt= %i Ypt= %i \n",npplate,points[itemp-1].x,points[itemp-1].y);}    */
	setfillstyle(1,ipen);                         /* set fill style to color polygon */
	setcolor(icolor);                             /* set color for current face for drawing  */

/*      fillpoly( npplate, (int far *)points ); */    /* use polyfill command to draw filled polygon */
	setlinestyle(SOLID_LINE,0,NORM_WIDTH);
	setcolor(10);
	drawpoly( npplate, (int far *)points );       /* outline object with line drawing around polygons */
/*	printf("Face # = %i\t",ipl);            */    /* print out face number currenly drawn */
/*	keyboard();                             */
	setcolor(icolor);                             /* set color for current face for drawing */
	drawpoly( npplate, (int far *)points ); };    /* outline object with line drawing around polygons */
/*        floodfill(sxavg,syavg,ipen);     };   */    /* fill in each plate */
        };                                            /* close plate loop   */
						      /* close rotation loop */


end_label: ;
        setvisualpage(0);
        setactivepage(0);
        setcolor(11);
	settextstyle(3,0,4);
	outtextxy(121,  1,"O   VLM  ENGINEERING  1996");
	settextstyle(3,0,2);
	outtextxy(125,  5,"c");

        keyboard();       }

/*-------------------------------------------------------------
        SUBROUTINE: CALCULATE SIN, COS FACTORS
   Enter with r1,r2,r3 viewing angles for yaw, roll, pitch
   expressed in radians.  Returns sine and cosine factors.   */

void rotation(void){
sr1=sin(r1); sr2=sin(r2); sr3=sin(r3);
cr1=cos(r1); cr2=cos(r2); cr3=cos(r3); return;}



/*-------------------------------------------------------------
        SUBROUTINE: STANDARD 3D FORMULAS
    Enter with x,y,z cartesian world coordinates.  Returns sx,sy
    cartesian display coordinates.  Returns x,y,z cartesian view
    coordinates which includes rotation and translation effects.  */

void calc_3d(void){
x=(-1)*x; xa=cr1*x-sr1*z; za=sr1*x+cr1*z; x=cr2*xa+sr2*y;
ya=cr2*y-sr2*xa; z=cr3*za-sr3*ya; y=sr3*za+cr3*ya;
x=x+movex; y=y+movey; z=z+movez;
if(z==0.) z=.00001;
sx=d*x/z; sy=d*y/z; return;}

/*-------------------------------------------------------------
        SUBROUTINE: MAXIMUM
   Returns larger of two real numbers                          */

float maximum(float x, float y){
if(x >= y) {return x;};
if(x <= y) {return y;}; }

/*-------------------------------------------------------------
        SUBROUTINE: MINIMUM
   Returns smaller of two real numbers                         */

float minimum(float x, float y){
if(x <= y) {return x;};
if(x >= y) {return y;}; }

/*--------------------------------------------------------------
	SUBROUTINE:  KEYBOARD - SCREEN HOLD UNTIL ESC KEY       */
void keyboard(void){
union u_type{int a; char b[3];} keystroke;
int get_keystroke(void);
do keystroke.a=get_keystroke();
while (keystroke.b[0]!=110); }

int get_keystroke(void){
union REGS regs;regs.h.ah=0; return int86(0x16,&regs,&regs);}

/*--------------------------------------------------------------
        SUBROUTINE: DYNAMIC KEYBOARD INPUT
                                                               */
void keyboard_input(void){
union u_type{int a; char b[3];}keystroke; char inkey=0;

if(bioskey(1)==0) return;                   /* if no key, return      */
keystroke.a=bioskey(0);                     /* fetch ASCII code...    */
inkey=keystroke.b[0];                       /* ... and load code into variable */
switch (inkey) {                            /* make decision based upon ASCII value */
case 27:  exit(0);                          /* exit on <Esc> key      */
case 61:  movez=movez+20; return;           /* + key = move outwards  */
case 45:  movez=movez-20; return;           /* - key = move inwards   */
case 104: rd1=rd1-2;      return;           /* h key roll right       */
case 102: rd1=rd1+2;      return;           /* f key roll left        */
case 103: rd1=0;rd2=0;rd3=0; return;        /* g key return to nominal position */
case 116: rd2=rd2+2;      return;           /* t key pitch forward    */
case 98:  rd2=rd2-2;      return;           /* b key pitch back       */
case 118: rd3=rd3-2;      return;           /* v key yaw back         */
case 121: rd3=rd3+2;      return;           /* y key yaw forward      */

default: return;} }                         /* make routine bullet-proof */
/*--------------------------------------------------------------
        SUBROUTINE:  VIC_SORT = DEPTH SORT BY BUBBLE SORT
        SORT ITEMS BY Z-DEPTH WITH LARGEST Z VALUE FIRST
        TO START DRAWING AT BACK OF SCREEN AND WORK FORWARDS

        OUTER LOOP KEEPS PERFORMING INNER LOOP UNTIL NO MORE SWAPPING OCCURS
        INNER LOOP STEPS THROUGH THE COMPLETE PLATE LIST AND
        COMPARES NEIGHBORING VALUES. WHEN THE FIRST OF THE PAIR
        HAS A SMALLER Z-DEPTH IT SWAPS IT WITH THE SECOND OF THE PAIR
        THIS WILL CONTINUE ALL THE WAY DOWN THE LIST.  WHEN EVERYTHING
        IS IN ORDER NO MORE SWAPS OCCUR AND THE OUTER LOOP STOPS        */

void vic_sort(void){

int   iloop, iloop2, iswapflag=1;
float dataarray[2][600];
float tempiplate, tempzdepth;

        for( iloop2=1; iloop2 <=46; iloop2++) {
        printf("%i, %f, %f",iloop2, dataarray[1][iloop2],
                                    dataarray[2][iloop2]); };

        for (iloop2=1; iloop2!=2; ) {                /* CHECK FOR NO MORE SWAPPING  */
        iswapflag=0;                                 /* START AT TOP OF PLATE LIST  */

        for (iloop=1; iloop<=(46-1); iloop++) {  /* LOOP THROUGH THE WHOLE LIST */
	printf("%i, %i, %f",iswapflag, iloop, dataarray[2][iloop]);
        if(dataarray[2][iloop] < dataarray[2][iloop+1]) {
                                                     /* COMPARE NEIGHBORING VALUES IN LIST
                                                        AND IF FIRST IS SMALLER THAN SECOND
                                                        THEN SWAP SO LARGER IS BEFORE SMALLER */

                                                     /* PERFORM SWAPPING */
        tempiplate=dataarray[1][iloop];
        tempzdepth=dataarray[2][iloop];
        dataarray[1][iloop]=dataarray[1][iloop+1];
        dataarray[2][iloop]=dataarray[2][iloop+1];
        dataarray[1][iloop+1]=tempiplate;
        dataarray[2][iloop+1]=tempzdepth;
	iswapflag=1; }; };
        if(iswapflag==0) goto end_out;  };
end_out: ;
	return;}